/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.move.GEnterDynamicScene
 *  fire.pb.GsClient
 *  fire.pb.PropRole
 *  fire.pb.map.Transfer
 *  fire.pb.mission.SLandTask
 *  fire.pb.scene.DynamicScene
 *  fire.pb.scene.SceneManager
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.DateValidate
 *  fire.pb.util.MessageUtil
 *  fire.pb.util.TaskDlgUtil
 *  fire.pb.util.TaskDlgUtil$NpcModel
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.InstanceInfo
 *  xbean.InstanceInfoCol
 *  xbean.InstanceNpcInfo
 *  xbean.InstanceTaskInfo
 *  xbean.Pod
 *  xtable.Instancetask
 *  xtable.Roleinstancetask
 */
package fire.pb.mission.instance;

import fire.msp.move.GEnterDynamicScene;
import fire.pb.GsClient;
import fire.pb.PropRole;
import fire.pb.map.Transfer;
import fire.pb.mission.SLandTask;
import fire.pb.mission.instance.InstanceManager;
import fire.pb.scene.DynamicScene;
import fire.pb.scene.SceneManager;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.DateValidate;
import fire.pb.util.MessageUtil;
import fire.pb.util.TaskDlgUtil;
import java.util.ArrayList;
import java.util.List;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.InstanceInfo;
import xbean.InstanceInfoCol;
import xbean.InstanceNpcInfo;
import xbean.InstanceTaskInfo;
import xbean.Pod;
import xtable.Instancetask;
import xtable.Roleinstancetask;

public class PBackInstanceScenceProc
extends Procedure {
    private final long roleId;
    private final int posx;
    private final int posy;

    public PBackInstanceScenceProc(long roleId) {
        this.roleId = roleId;
        this.posx = 0;
        this.posy = 0;
    }

    public PBackInstanceScenceProc(long roleId, int x, int y) {
        this.roleId = roleId;
        this.posx = x;
        this.posy = y;
    }

    protected boolean process() throws Exception {
        InstanceTaskInfo instanceInfo;
        Team team = TeamManager.selectTeamByRoleId((long)this.roleId);
        if (team == null) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleId, (int)145123, null);
            return false;
        }
        if (team.isReturnMember(this.roleId)) {
            return false;
        }
        ArrayList<Long> list = new ArrayList<Long>();
        list.addAll(team.getAllMemberIds());
        InstanceInfoCol teamLeaderInfoCol = Roleinstancetask.get((Long)team.getTeamLeaderId());
        if (teamLeaderInfoCol == null) {
            return false;
        }
        InstanceTaskInfo teamLeaderInfo = (InstanceTaskInfo)teamLeaderInfoCol.getInstinfo().get(teamLeaderInfoCol.getLastinstanceid());
        if (teamLeaderInfo == null) {
            return false;
        }
        long instanceTaskid = teamLeaderInfo.getInstanceonlyid();
        InstanceInfo instInfo = Instancetask.get((Long)instanceTaskid);
        if (instInfo == null) {
            return false;
        }
        int taskType = instInfo.getInstanceid();
        int mapId = InstanceManager.getInstance().getMapIdByTaskType(taskType, instInfo.getCurrentstep());
        SLandTask taskCofig = InstanceManager.getInstance().getInstanceTask(taskType);
        if (taskCofig != null && !this.checkLevel(list, taskCofig)) {
            return false;
        }
        int instanceZoneId = teamLeaderInfoCol.getLastinstanceid();
        InstanceInfoCol taskInfo = Roleinstancetask.get((Long)this.roleId);
        if (taskInfo == null) {
            taskInfo = Pod.newInstanceInfoCol();
            Roleinstancetask.insert((Long)this.roleId, (InstanceInfoCol)taskInfo);
        }
        if ((instanceInfo = (InstanceTaskInfo)taskInfo.getInstinfo().get(instanceZoneId)) == null) {
            instanceInfo = Pod.newInstanceTaskInfo();
            taskInfo.getInstinfo().put(instanceZoneId, instanceInfo);
        }
        taskInfo.setLastinstanceid(instanceZoneId);
        long currentTime = System.currentTimeMillis();
        if (!DateValidate.inTheSameDay((long)taskInfo.getAccepttime(), (long)currentTime)) {
            taskInfo.setCounts(0);
            taskInfo.setAccepttime(currentTime);
        }
        int defaultTimes = InstanceManager.getInstance().getDayMaxTimes(this.roleId);
        if (!DateValidate.inTheSameDay((long)instanceInfo.getAccepttime(), (long)teamLeaderInfo.getAccepttime())) {
            instanceInfo.setCounts(0);
            instanceInfo.setDefaulttimes(defaultTimes);
            instanceInfo.setCurrentstep(0);
            instanceInfo.setCurrenttaskid(0);
        }
        taskInfo.setAccepttime(teamLeaderInfoCol.getAccepttime());
        instanceInfo.setAccepttime(teamLeaderInfo.getAccepttime());
        instanceInfo.setInstanceonlyid(teamLeaderInfo.getInstanceonlyid());
        instanceInfo.setCurrentstep(teamLeaderInfo.getCurrentstep());
        instanceInfo.setCurrenttaskid(teamLeaderInfo.getCurrenttaskid());
        instanceInfo.setInstanceflag(teamLeaderInfo.getInstanceflag());
        int questid = instInfo.getCurrenttaskid();
        instInfo.getRoleids().add(this.roleId);
        InstanceNpcInfo info = null;
        if (instInfo.getNpcs().size() > 0) {
            info = (InstanceNpcInfo)instInfo.getNpcs().get(0);
        }
        if (info == null) {
            InstanceManager.logger.info((Object)("Instance info == null   mission.roleids=:" + instInfo.getRoleids() + "taskid:" + questid));
            return false;
        }
        TaskDlgUtil.NpcModel npcModel = TaskDlgUtil.createNpcModel((long)info.getNpckey(), (int)info.getNpcid(), (int)info.getMapid(), (int)info.getPosx(), (int)info.getPosy());
        TaskDlgUtil.createAndRefreshTaskDlg((long)this.roleId, (int)questid, (TaskDlgUtil.NpcModel)npcModel, (int)1, (int)1, (int)3, (long)(instanceInfo.getAccepttime() + 0x6DDD00L - System.currentTimeMillis()));
        DynamicScene ds = SceneManager.getInstance().getSceneByMapAndOwner(mapId, instanceTaskid);
        if (ds == null) {
            return false;
        }
        if (!Transfer.canChangeMap((long)this.roleId, (int)516022, (int)0)) {
            return false;
        }
        GsClient.pSendWhileCommit((Protocol)new GEnterDynamicScene(this.roleId, mapId, instanceTaskid, "", this.posx, this.posy, 1, 0x6DDD00, 0, 516026, null));
        return true;
    }

    private boolean checkLevel(List<Long> allRoleIDs, SLandTask taskCofig) {
        ArrayList<Long> levelException = new ArrayList<Long>();
        for (Long mem : allRoleIDs) {
            PropRole pRole = new PropRole(mem.longValue(), true);
            int level = pRole.getLevel();
            if (level >= taskCofig.getMinlevel() && level <= taskCofig.getMaxlevel()) continue;
            levelException.add(mem);
        }
        if (!levelException.isEmpty()) {
            List paras = MessageUtil.getMsgParaList((String[])new String[]{MessageUtil.getRoleNames(levelException)});
            paras.add(String.valueOf(taskCofig.getMinlevel()));
            for (long rid : allRoleIDs) {
                MessageMgr.psendMsgNotifyWhileRollback((long)rid, (int)143221, (int)0, (List)paras);
            }
            return false;
        }
        return true;
    }
}

